#!/bin/sh
#======================================================================
# macOS shell script to run the site generation demo
#======================================================================

#----------------------------------------------------------------------
# Specify the location of Apache Maven here
#----------------------------------------------------------------------
export M2_HOME="/Users/Shared/apache-maven-3.8.2"

#----------------------------------------------------------------------
# Setting the initial and maximum heap size allocated by JVM when
# running Maven.
#
# Since FlexDoc/XML generator will be executed in the same JVM, check
# this option when you need to process large quantities of data!
#
# The JVM options below set the initial and maximum Java heap size to
# 2048 Mb and 4096 Mb respectively.
#----------------------------------------------------------------------
export MAVEN_OPTS="-Xms2048m -Xmx4096m"

#----------------------------------------------------------------------
# Change current directory to the parent of this script file
# (otherwise Maven won't find the POM file)
#----------------------------------------------------------------------
cd $(dirname $0)

#----------------------------------------------------------------------
# Run the site generation
#----------------------------------------------------------------------
# NOTE: To use 'pom_JavaFX_SDK.xml', specifying it with -f option, e.g.
#
# "$M2_HOME/bin/mvn" -f pom_JavaFX_SDK.xml site:site
#----------------------------------------------------------------------
"$M2_HOME/bin/mvn" site:site