<FLEXDOCXYZ_TEMPLATE VER='1.23'>
CREATED='2018-09-17 03:28:47'
LAST_UPDATE='2021-11-28 13:49:07'
DESIGNER_TOOL='FlexDoc.XYZ SDK 1.x'
DESIGNER_LICENSE_TYPE='Filigris Works Team'
APP_ID='flexdoc-xml-xsddoc2'
APP_NAME='FlexDoc/XML XSDDoc'
APP_VER='2.9.5'
APP_AUTHOR='Copyright © 2005-2021 Filigris Works, Leonid Rudy Softwareprodukte. All rights reserved.'
TEMPLATE_TYPE='DocumentTemplate'
DSM_TYPE_ID='xsddoc'
ROOT_ETS={'xs:%element';'xs:attributeGroup';'xs:complexType'}
<TEMPLATE_PARAMS>
	PARAM={
		param.name='$mainXSD';
		param.type='GOMElement';
		param.defaultValue.expr='findElementByKey ("main-xsds", getXMLDocument().id)';
	}
	PARAM={
		param.name='$contentModelKey';
		param.title='"content-model-attributes" map key';
		param.description='The key for "content-model-attributes" map to find all attributes associated with this schema component';
		param.type='Object';
		param.defaultValue.expr='contextElement.id';
	}
	PARAM={
		param.name='$caption';
		param.type='string';
		param.defaultValue='Content Model Attributes ({0}):';
	}
	PARAM={
		param.name='$showValueInfo';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='$includeWildcards';
		param.type='boolean';
		param.defaultValue='true';
	}
	PARAM={
		param.name='$abbreviateAttrValue';
		param.description='Indicates that when an attribute value representation consists of the only enumeration, it should be abbreviated (shown as "enumeration of ...")';
		param.type='boolean';
	}
	PARAM={
		param.name='show';
		param.title='Show';
		param.title.style.bold='true';
		param.group='true';
		param.group.defaultState='expanded';
	}
	PARAM={
		param.name='show.linkTitle';
		param.title='Link Titles (Tooltips)';
		param.type='boolean';
	}
</TEMPLATE_PARAMS>
<STYLES>
	CHAR_STYLE={
		style.name='Component List';
		style.id='cs1';
		text.font.size='10';
	}
	PAR_STYLE={
		style.name='Component List Heading 1';
		style.id='ps1';
		text.font.name='Arial';
		text.font.size='10';
		text.font.style.bold='true';
		par.margin.top='10';
		par.margin.bottom='7';
		par.page.keepWithNext='true';
	}
	CHAR_STYLE={
		style.name='Default Paragraph Font';
		style.id='cs2';
		style.default='true';
	}
	CHAR_STYLE={
		style.name='Hyperlink';
		style.id='cs3';
		text.decor.underline='true';
		text.color.foreground='#0000FF';
	}
	CHAR_STYLE={
		style.name='Mono';
		style.id='cs4';
		style.css.className='mono';
		text.font.name='Monospaced';
		text.font.size='9';
	}
	PAR_STYLE={
		style.name='Normal';
		style.id='ps2';
		style.default='true';
	}
</STYLES>
FMT={
	doc.lengthUnits='pt';
	doc.hlink.style.link='cs3';
}
<ROOT>
	<FOLDER>
		COND='e = findElementsByKey (
      "content-model-attributes",

      // the key to find all items associated with this component
      getParam("$contentModelKey"),

      // exclude wildcards and attribute prohibitions
      getBooleanParam("$includeWildcards")
        ? BooleanQuery (
            instanceOf ("xs:anyAttribute") ||
            instanceOf ("xs:%attribute") && getAttrValue("use") != "prohibited"
          )
        : BooleanQuery (
            instanceOf ("xs:%attribute") && getAttrValue("use") != "prohibited"
          )
    );

e.hasNext() ?
{
  v = e.toVector();

  v.sortVector (
     @(GOMElement) el,
     StringQuery (
       el.instanceOf("xs:%attribute") ?
         el.hasAttr("name")
          ? el.callStockSection("Attribute Name (local)") 
          : el.getAttrQNameValue("ref").toXMLName (Array (rootElement, el))
       : "{any}"
     ),
     false
  );

  thisContext.setVar ("attributes", v);
  true;

} : false'
		<HEADER>
			<AREA_SEC>
				FMT={
					sec.outputStyle='pars';
					par.style='ps1';
				}
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<DATA_CTRL>
								EXPR='formatString (
  getStringParam("$caption"),
  thisContext.getVar("attributes").toVector().size()
)'
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</HEADER>
		<BODY>
			<FOLDER>
				DESCR='with type/value info'
				COND='getBooleanParam("$showValueInfo")'
				BREAK_PARENT_BLOCK='when-executed'
				<BODY>
					<ELEMENT_ITER>
						TARGET_ET='xs:%attribute'
						SCOPE='custom'
						ELEMENT_ENUM_EXPR='thisContext.getVar("attributes").toEnum()'
						FILTER='! instanceOf ("xs:anyAttribute")'
						FMT={
							sec.outputStyle='table';
							sec.page.keepTogether='true';
							table.cell.padding.both='0';
							table.border.style='none';
						}
						<BODY>
							<AREA_SEC>
								DESCR='case of local attribute'
								COND='getAttrStringValue("name") != ""'
								BREAK_PARENT_BLOCK='when-executed'
								<AREA>
									<CTRL_GROUP>
										FMT={
											trow.cell.align.vert='Top';
											txtfl.separator.type='none';
										}
										<CTRLS>
											<SS_CALL_CTRL>
												SS_NAME='Attribute Name (local)'
												FMT={
													ctrl.size.width='126.8';
													ctrl.size.height='18';
													tcell.option.nowrap='true';
													text.style='cs4';
												}
											</SS_CALL_CTRL>
											<TEXT_CTRL>
												TEXT=' = '
												FMT={
													ctrl.size.width='19.5';
													ctrl.size.height='18';
													tcell.align.horz='Center';
													text.style='cs4';
													text.spacing.nbsp='true';
												}
											</TEXT_CTRL>
											<SS_CALL_CTRL>
												SS_NAME='Attribute Value'
												FMT={
													content.outputStyle='text-par';
													ctrl.size.width='353.3';
													ctrl.size.height='18';
													text.style='cs4';
												}
											</SS_CALL_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
							<AREA_SEC>
								DESCR='case of reference to global attribute'
								COND='getAttrValue("ref") != null'
								<AREA>
									<CTRL_GROUP>
										FMT={
											trow.cell.align.vert='Top';
											txtfl.separator.type='none';
										}
										<CTRLS>
											<SS_CALL_CTRL>
												SS_NAME='Attribute Name (reference)'
												FMT={
													ctrl.size.width='126.8';
													ctrl.size.height='18';
													tcell.sizing='Minimal';
													tcell.option.nowrap='true';
													text.style='cs4';
												}
											</SS_CALL_CTRL>
											<TEXT_CTRL>
												TEXT=' = '
												FMT={
													ctrl.size.width='19.5';
													ctrl.size.height='18';
													tcell.align.horz='Center';
													text.style='cs4';
													text.spacing.nbsp='true';
												}
											</TEXT_CTRL>
											<SS_CALL_CTRL>
												SS_NAME='Attribute Value'
												PASSED_ELEMENT_EXPR='findElementByKey (
  "global-attributes", getAttrQNameValue("ref"),
  BooleanQuery (
    checkElementByKey (
      "main-xsds",
      getXMLDocument().id,
      getElementParam("$mainXSD")
    )
  )
)'
												PASSED_ELEMENT_MATCHING_ET='xs:attribute'
												PARAMS_EXPR='Array (contextElement)'
												ALT_EXPR='"???"'
												FMT={
													content.outputStyle='text-par';
													ctrl.size.width='353.3';
													ctrl.size.height='18';
													text.style='cs4';
												}
											</SS_CALL_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</BODY>
					</ELEMENT_ITER>
					<ELEMENT_ITER>
						COND='getBooleanParam("$includeWildcards")'
						TARGET_ET='xs:anyAttribute'
						SCOPE='custom'
						ELEMENT_ENUM_EXPR='thisContext.getVar("attributes").toEnum()'
						FILTER='instanceOf ("xs:anyAttribute")'
						<BODY>
							<AREA_SEC>
								<AREA>
									<CTRL_GROUP>
										<CTRLS>
											<SS_CALL_CTRL>
												SS_NAME='Any Attribute'
												FMT={
													text.style='cs4';
													text.font.style.italic='true';
												}
												<DOC_HLINK>
													DESCR='try to link to wildcard\'s detail by this component;
otherwise, link to wildcard\'s details by its parent component (where the attribute is defined);
if not found still, link to the XML schema source location, where this wildcard is defined'
													CONTEXT_ELEMENT_EXPR='findElementByKey (
  "content-model-attributes", 
  getParam("$contentModelKey"),
  BooleanQuery (instanceOf ("xs:anyAttribute"))
)'
													MATCHING_ET='xs:anyAttribute'
													TITLE_EXPR='getBooleanParam("show.linkTitle") ? "attribute wildcard"'
													HKEYS={
														'contextElement.id';
														'Array ("local", "def", "xml-source-location")';
														'Array (rootElement.id, NoKey())';
													}
												</DOC_HLINK>
											</SS_CALL_CTRL>
										</CTRLS>
									</CTRL_GROUP>
								</AREA>
							</AREA_SEC>
						</BODY>
					</ELEMENT_ITER>
				</BODY>
			</FOLDER>
			<ELEMENT_ITER>
				DESCR='just list of attribute names'
				TARGET_ETS={'xs:%attribute';'xs:anyAttribute'}
				SCOPE='custom'
				ELEMENT_ENUM_EXPR='thisContext.getVar("attributes").toEnum()'
				FMT={
					sec.outputStyle='list';
					text.style='cs1';
					list.type='delimited';
				}
				<BODY>
					<SS_CALL>
						DESCR='case of local attribute'
						COND='getAttrStringValue("name") != ""'
						MATCHING_ET='xs:%attribute'
						BREAK_PARENT_BLOCK='when-executed'
						SS_NAME='Attribute Name (local)'
					</SS_CALL>
					<SS_CALL>
						DESCR='case of reference to global attribute'
						COND='getAttrValue("ref") != null'
						MATCHING_ET='xs:%attribute'
						BREAK_PARENT_BLOCK='when-executed'
						SS_NAME='Attribute Name (reference)'
					</SS_CALL>
					<AREA_SEC>
						DESCR='case of wildcard'
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<TEXT_CTRL>
										TEXT='{any attribute}'
										FMT={
											text.font.style.italic='true';
										}
										<DOC_HLINK>
											DESCR='try to link to wildcard\'s detail by this component;
otherwise, link to wildcard\'s details by its parent component (where the attribute is defined);
if not found still, link to the XML schema source location, where this wildcard is defined'
											CONTEXT_ELEMENT_EXPR='findElementByKey (
  "content-model-attributes", 
  getParam("$contentModelKey"),
  BooleanQuery (instanceOf ("xs:anyAttribute"))
)'
											MATCHING_ET='xs:anyAttribute'
											TITLE_EXPR='getBooleanParam("show.linkTitle")
  ? callStockSection("Any Attribute")'
											HKEYS={
												'contextElement.id';
												'Array ("local", "def", "xml-source-location")';
												'Array (rootElement.id, NoKey())';
											}
										</DOC_HLINK>
									</TEXT_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</ELEMENT_ITER>
		</BODY>
	</FOLDER>
</ROOT>
<STOCK_SECTIONS>
	<TEMPLATE_CALL>
		SS_NAME='Any Attribute'
		MATCHING_ET='xs:anyAttribute'
		TEMPLATE_FILE='../component/wildcard.tpl'
	</TEMPLATE_CALL>
	<TEMPLATE_CALL>
		SS_NAME='Attribute Link Title'
		TEMPLATE_FILE='../component/componentLinkTitle.tpl'
	</TEMPLATE_CALL>
	<AREA_SEC>
		SS_NAME='Attribute Name (local)'
		MATCHING_ET='xs:%attribute'
		<AREA>
			<CTRL_GROUP>
				<CTRLS>
					<DATA_CTRL>
						EXPR='name = getAttrStringValue("name");
schema = findAncestor ("xs:schema");

form = hasAttr("form") ? getAttrValue("form") :
         schema.getAttrValue ("attributeFormDefault");

form == "qualified" ? 
  toXMLName (schema.getServiceAttr("targetNamespace").toString(), name,
             Array (rootElement, contextElement))
  : name'
						<DOC_HLINK>
							DESCR='try to link to the attribute\'s detail by this component;
otherwise, link to the attribute\'s details by its parent component (where the attribute is defined);
if not found still, link to the XML schema source location, where this attribute is defined'
							TITLE_EXPR='getBooleanParam("show.linkTitle") ?
  callStockSection("Attribute Link Title")'
							HKEYS={
								'contextElement.id';
								'Array ("local", "def", "xml-source-location")';
								'Array (rootElement.id, NoKey())';
							}
						</DOC_HLINK>
					</DATA_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
	<AREA_SEC>
		SS_NAME='Attribute Name (reference)'
		MATCHING_ET='xs:%attribute'
		INIT_EXPR='stockSection.setVar (
  "globalAttr", 
  findElementByKey (
    "global-attributes", getAttrQNameValue("ref"),
    BooleanQuery (
      checkElementByKey (
        "main-xsds",
        getXMLDocument().id,
        getElementParam("$mainXSD")
      )
    )
  )
)'
		<AREA>
			<CTRL_GROUP>
				<CTRLS>
					<DATA_CTRL>
						EXPR='getAttrQNameValue("ref").toXMLName (Array (rootElement, contextElement))'
						<DOC_HLINK>
							DESCR='try to link to attribute\'s detail by this component;
otherwise, link to the attribute\'s detail by its parent component (where the attribute reference is defined);
if not found, link to the attribute\'s global documentation;
finally, try to link to the location in the XML schema source, where this attribute reference is defined'
							TITLE_EXPR='getBooleanParam("show.linkTitle") ?
 (globalAttr = stockSection.getElementVar("globalAttr")) != null ? 
   globalAttr.callStockSection ("Attribute Link Title") : "global attribute"'
							HKEYS={
								'Array (
  contextElement.id,
  contextElement.id,
  stockSection.getElementVar("globalAttr").id,
  contextElement.id
)';
								'Array (
  "local",
  "def",
  "detail",
  "xml-source-location"
)';
								'Array (rootElement.id, NoKey())';
							}
						</DOC_HLINK>
					</DATA_CTRL>
				</CTRLS>
			</CTRL_GROUP>
		</AREA>
	</AREA_SEC>
	<FOLDER>
		SS_NAME='Attribute Value'
		DESCR='the passed context element must be the attribute declaration component (not a reference to it);

params[0]: in case of reference to a global attribute, the reference-attribute should be passed in the stock-section parameter'
		MATCHING_ET='xs:%attribute'
		FMT={
			sec.outputStyle='text-par';
		}
		<BODY>
			<AREA_SEC>
				DESCR='if the attribute value is fixed'
				COND='! getBooleanParam("$abbreviateAttrValue")'
				CONTEXT_ELEMENT_EXPR='hasAttr("fixed") ? contextElement :
{
  refAttr = stockSection.param.toElement();
  refAttr.hasAttr("fixed") ? refAttr : null
}'
				MATCHING_ET='xs:%attribute'
				BREAK_PARENT_BLOCK='when-executed'
				<AREA>
					<CTRL_GROUP>
						FMT={
							txtfl.separator.type='none';
						}
						<CTRLS>
							<TEXT_CTRL>
								TEXT='"'
							</TEXT_CTRL>
							<DATA_CTRL>
								ATTR='fixed'
							</DATA_CTRL>
							<TEXT_CTRL>
								TEXT='"'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
			<FOLDER>
				DESCR='no fixed value'
				<BODY>
					<SS_CALL>
						DESCR='if there is \'type\' attribute'
						COND='hasAttr("type")'
						BREAK_PARENT_BLOCK='when-executed'
						SS_NAME='Simple Content Model'
						PASSED_ELEMENT_EXPR='typeQName = getAttrQNameValue("type");

type = findElementByKey (
  "types",
  typeQName,
  BooleanQuery (checkElementByKey (
    "main-xsds",
    getXMLDocument().id,
    getElementParam("$mainXSD")
  ))
);

(type != null) ? type : CustomElement (typeQName)'
						PASSED_ELEMENT_MATCHING_ETS={'#CUSTOM';'xs:%simpleType'}
						PARAMS_EXPR='Array (
 false, // highlight XML markup
 true,  // always apply brackets
 getBooleanParam("$abbreviateAttrValue")
)'
					</SS_CALL>
					<SS_CALL>
						DESCR='otherwise, if there is anonymous type'
						CONTEXT_ELEMENT_EXPR='findChild("xs:simpleType")'
						MATCHING_ET='xs:%simpleType'
						BREAK_PARENT_BLOCK='when-executed'
						SS_NAME='Simple Content Model'
						PARAMS_EXPR='Array (
 false, // highlight XML markup
 true,  // always apply brackets
 getBooleanParam("$abbreviateAttrValue")
)'
					</SS_CALL>
					<AREA_SEC>
						DESCR='otherwise, no type information is specified at all'
						<AREA>
							<CTRL_GROUP>
								<CTRLS>
									<DATA_CTRL>
										EXPR='toXMLName (
  getNamespaceURI("xs"),
  "anySimpleType",
  rootElement
)'
									</DATA_CTRL>
								</CTRLS>
							</CTRL_GROUP>
						</AREA>
					</AREA_SEC>
				</BODY>
			</FOLDER>
			<AREA_SEC>
				DESCR='add default value, when specified'
				CONTEXT_ELEMENT_EXPR='refAttr = stockSection.param.toElement();

refAttr.hasAttr("default") ? refAttr :
  hasAttr("default") ? contextElement : null'
				MATCHING_ET='xs:%attribute'
				<AREA>
					<CTRL_GROUP>
						FMT={
							txtfl.separator.type='none';
						}
						<CTRLS>
							<SEPARATOR>
								FMT={
									txtfl.separator.type='text';
									txtfl.separator.text=' : ';
								}
							</SEPARATOR>
							<TEXT_CTRL>
								TEXT='"'
							</TEXT_CTRL>
							<DATA_CTRL>
								ATTR='default'
							</DATA_CTRL>
							<TEXT_CTRL>
								TEXT='"'
							</TEXT_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</FOLDER>
	<FOLDER>
		SS_NAME='Simple Content Model'
		DESCR='params[0]: highlight XML markup;
params[1]: apply all brackets
params[2]: abbreviate simple content representation'
		MATCHING_ETS={'#CUSTOM';'xs:%complexType';'xs:%simpleType'}
		FMT={
			sec.outputStyle='text-par';
		}
		<BODY>
			<TEMPLATE_CALL>
				MATCHING_ETS={'xs:%complexType';'xs:%simpleType'}
				BREAK_PARENT_BLOCK='when-executed'
				TEMPLATE_FILE='../component/simpleContentRep.tpl'
				PASSED_PARAMS={
					'$highlightMarkup','stockSection.params[0].toBoolean()';
					'$applyBrackets','stockSection.params[1].toBoolean()';
					'$abbreviateEnum','stockSection.params[2].toBoolean()';
				}
			</TEMPLATE_CALL>
			<AREA_SEC>
				MATCHING_ET='#CUSTOM'
				<AREA>
					<CTRL_GROUP>
						<CTRLS>
							<DATA_CTRL>
								EXPR='toXMLName (contextElement.value.toQName(), rootElement)'
							</DATA_CTRL>
						</CTRLS>
					</CTRL_GROUP>
				</AREA>
			</AREA_SEC>
		</BODY>
	</FOLDER>
</STOCK_SECTIONS>
CHECKSUM='zONUcBZKSnDkdSzolqLVT3FvWDk0JMilrj1ga6P02N8'
</FLEXDOCXYZ_TEMPLATE>